//TesterTexteEnExces_304f.js / CS3
// 07.08.07 / Hans Haesler, Chtelard 52, CH-1018 Lausanne / <hsa@ringier.ch>
//Ce script tente de trouver des blocs texte avec de texte en excs

// tester si un document est ouvert
if (app.documents.length == 0) {
	alert ("Il n'y a pas de document ouvert.", "Attention");
	exit();
}

var curDoc = app.documents[0];

// prparer trois variables
var tmpList = new Array();
var aCtr = 0;
var cCtr = 0;

// une boucle  travers les pages...
for (var i=0; i<curDoc.pages.length; i++) {
	var nFrames = curDoc.pages[i].textFrames.length;
	for (var j=0; j<nFrames; j++) {
		if (curDoc.pages[i].textFrames[j].overflows == true) {
			var pName = curDoc.pages[i].name;
			tmpList.push(pName);
			break;
		}
	}
	//... sans oublier des groupes eventuels 
	var curGroups = curDoc.pages[i].groups;
	for (var j=0; j<curGroups.length; j++) {
		var allFrames = curGroups[j].allPageItems;
		for (var k=0; k<allFrames.length; k++) {
			var curFrame = allFrames[i];
			var curType = curFrame.constructor.name;
			if (curType == "TextFrame") {
				if (curFrame.overflows == true) {
					var pName = curDoc.pages[i].name;
					tmpList.push(pName);
					break;
				}
			}
		}
	}
}

// une boucle  travers les stories
var nStories = curDoc.stories.length;
for (var i=0; i<nStories; i++) {
	try {
		if (curDoc.stories[i].textFrames.item(-1).overflows) {
			try {
				var pName = curDoc.stories[i].textFrames.item(-1).parent.name;
			}
			catch (e) {
				aCtr++;
			}
		}
	}
	catch (e) {	
	}
	var allTables = curDoc.stories[i].tables;
	var nTables = allTables.length;
	if (nTables != 0) {
		for (var j=0; j<nTables; j++) {
			var allCells = allTables[j].cells;
			var nCells = allCells.length;
			for (var k=0; k<nCells; k++) {
				if (allCells[k].overflows) {
					cCtr++;
					break;
				}
			}
		}
	}
}

// rduire des doublons ventuels
var pageList = new Array();
for (var i=0; i<tmpList.length; i++) {
	var curItem = tmpList[i];
	var okay = true;
	for (var j=0; j<pageList.length; j++) {
		if (curItem == pageList[j]) {
			okay = false;
			break;
		}
	}
	if (okay) {
		pageList.push(curItem);
	}
}

// vrifier les valeurs de la liste et du compteur
// et afficher le dialogue correspondant
if (aCtr == 0 && cCtr == 0) {
	if (pageList.length == 0) {
		alert ("Il n'y a pas de texte en excs.", "Le document est en ordre");
	}
	else if (pageList.length == 1) {
		alert ("Il y a du texte en excs  la page " + pageList[0], "Attention");
	}
	else {
		pageString = pageList.join(", ");
		alert ("Il y a du texte en excs aux pages:\n\n" + pageString, "Attention");
	}
}
else {
	if (pageList.length == 0) {
		alert ("Tableaux avec du texte en excs: = " + cCtr + "\nBlocs ancrs avec du texte en excs: " + aCtr + "\n(pages non dfinies).", "Attention");
	}
	else if (pageList.length == 1) {
		alert ("Il y a du texte en excs  la page " + pageList[0] + "\n\nEt aussi (pages non dfinies):\nTableaux avec du texte en excs: " + cCtr + "\nBlocs ancrs avec du texte en excs: " + aCtr, "Attention");
	}
	else {
		pageString = pageList.join(", ");
		alert ("Il y a du texte en excs aux pages:\n" + pageString + "\n\nEt aussi (pages non dfinies):\nTableaux avec du texte en excs: " + cCtr + "\nBlocs ancrs avec du texte en excs: " + aCtr, "Attention");
	}
}